【强连通分量】Bzoj1654 [Usaco2006 Jan]The Cow Prom 奶牛舞会

Description

约翰的N(2≤N≤10000)只奶牛非常兴奋,因为这是舞会之夜!她们穿上礼服和新鞋子,别上鲜花,她们要表演圆舞.

只有奶牛才能表演这种圆舞.圆舞需要一些绳索和一个圆形的水池.奶牛们围在池边站好,顺时针顺序由1到N编号.每只奶牛都面对水池,这样她就能看到其他的每一只奶牛.为了跳这种圆舞,她们找了M(2≤M≤50000)条绳索.若干只奶牛的蹄上握着绳索的一端,绳索沿顺时针方绕过水池,另一端则捆在另一些奶牛身上.这样,一些奶牛就可以牵引另一些奶牛.有的奶牛可能握有很多绳索,也有的奶牛可能一条绳索都没有对于一只奶牛,比如说贝茜,她的圆舞跳得是否成功,可以这样检验:沿着她牵引的绳索,找到她牵引的奶牛,再沿着这只奶牛牵引的绳索,又找到一只被牵引的奶牛,如此下去,若最终能回到贝茜,则她的圆舞跳得成功,因为这一个环上的奶牛可以逆时针牵引而跳起旋转的圜舞.如果这样的检验无法完成,那她的圆舞是不成功的.

如果两只成功跳圆舞的奶牛有绳索相连,那她们可以同属一个组合.

给出每一条绳索的描述,请找出,成功跳了圆舞的奶牛有多少个组合?

Sulotion

裸强连通分量,我就测试下模板。。

Code

 1 #include<cstdio>
 2 #include<algorithm>
 3 using namespace std;
 4 const int maxn=1e5+5;
 5
 6 int pre[maxn],low[maxn],clock;
 7 int bcc[maxn],size[maxn],cnt;
 8 int head[maxn],e[maxn],nxt[maxn],k;
 9 int adde(int u,int v){
10     e[++k]=v,nxt[k]=head[u];
11     head[u]=k;
12 }
13 int a[maxn],t;
14 int n,m;
15
16 int dfs(int u){
17     pre[u]=low[u]=++clock;
18     a[++t]=u;
19     for(int i=head[u];i;i=nxt[i]){
20         int v=e[i];
21         if(!pre[v]){
22             dfs(v);
23             low[u]=min(low[u],low[v]);
24         }
25         else if(!bcc[v]){
26             low[u]=min(low[u],pre[v]);
27         }
28     }
29     if(low[u]==pre[u]){
30         ++cnt;
31         while(t){
32             bcc[a[t]]=cnt;
33             size[cnt]++;
34             if(a[t--]==u) break;
35         }
36     }
37 }
38
39 int main(){
40     scanf("%d%d",&n,&m);
41     int u,v;
42     for(int i=1;i<=m;i++){
43         scanf("%d%d",&u,&v);
44         adde(u,v);
45     }
46
47     for(int i=1;i<=n;i++)
48         if(!pre[i]) dfs(i);
49
50     int ans=0;
51     for(int i=1;i<=cnt;i++)
52         if(size[i]>1) ans++;
53     printf("%d\n",ans);
54
55     return 0;
56 }
时间: 2024-10-08 22:56:49

【强连通分量】Bzoj1654 [Usaco2006 Jan]The Cow Prom 奶牛舞会的相关文章

BZOJ1654 [Usaco2006 Jan]The Cow Prom 奶牛舞会

看不懂题,蒟蒻中文英文都太差了... 于是Orz itwiiioi巨巨! 结果终于理解了:就是求有向图非单点的强连通分量个数. tarjan妥妥的...(板子*1 get√) 1 /************************************************************** 2 Problem: 1654 3 User: rausen 4 Language: C++ 5 Result: Accepted 6 Time:32 ms 7 Memory:1476 kb

1654: [Usaco2006 Jan]The Cow Prom 奶牛舞会

1654: [Usaco2006 Jan]The Cow Prom 奶牛舞会 Time Limit: 5 Sec  Memory Limit: 64 MBSubmit: 471  Solved: 339[Submit][Status][Discuss] Description The N (2 <= N <= 10,000) cows are so excited: it's prom night! They are dressed in their finest gowns, complet

bzoj:1654: [Usaco2006 Jan]The Cow Prom 奶牛舞会

Description The N (2 <= N <= 10,000) cows are so excited: it's prom night! They are dressed in their finest gowns, complete with corsages and new shoes. They know that tonight they will each try to perform the Round Dance. Only cows can perform the

【BZOJ1654】[Usaco2006 Jan]The Cow Prom 奶牛舞会 赤果果的tarjan

Description The N (2 <= N <= 10,000) cows are so excited: it's prom night! They are dressed in their finest gowns, complete with corsages and new shoes. They know that tonight they will each try to perform the Round Dance. Only cows can perform the

P1654: [Usaco2006 Jan]The Cow Prom 奶牛舞会

裸的强连通 1 const maxe=50001; 2 type 3 node=record 4 f,t:longint; 5 end; 6 var n,m,dgr,i,u,v,num,ans:longint; 7 bfsdgr,low,head,f:array[0..maxe] of longint; 8 b:array[0..maxe] of node; 9 p:array[0..maxe] of boolean; 10 procedure insert(u,v:longint); 11 b

bzoj 1654: [Usaco2006 Jan]The Cow Prom 奶牛舞会【tarjan】

几乎是板子,求有几个size>1的scc 直接tarjan即可 #include<iostream> #include<cstdio> #include<cstring> using namespace std; const int N=10005; int n,m,h[N],cnt,ans,tmp,dfn[N],low[N],s[N],top; bool v[N]; struct qwe { int ne,to; }e[N*10]; int read() { i

POJ-3180 The Cow Prom(tarjan求强连通分量)

题目链接:http://poj.org/problem?id=3180 题目大意:求一个有向图的强连通分量 算法:求强连通分量首选tarjan算法 这里简单说一下tarjan的思路 时间戳是什么:在搜索时访问的最早时间 维护dfn[u]表示u的时间戳 low[u]表示u点所能回到的最早的祖先的时间戳 开一个栈,把搜索的点入栈.搜索时遇到已经搜过的点,取low[u]和dfn[v]的最小值,回溯时取low[u]和low[v]的最小值(标记上传)传到dfn[u]<=low[u]时表示已经回溯到最上面的

POJ2375 Cow Ski Area (添最少边构造强连通分量的某个与入度出度相关的结论)

题意:本题描述了一片滑雪场,并且规定奶牛从一个点只能向它相邻的并且高度不大于它的点运动,现在想要在某些点对之间加上缆车使得奶牛也可以从较低点到达较高点,问最少需要多少辆这样的缆车就可以使得奶牛可以从任意一个点运动到滑雪场的每个角落. 思路:即问至少加多少条边使图变成强联通图,先缩点成DAG. 不难知道强连通分量的所有节点的入度和出度均不为0,可以统计DAG上的入度和出度为0的个数分别是a,b.然后答案即为max(a,b). 只是发现入度为0和出度为0的点可以按某种方式相连接总能构造出一个强连通分

POJ 2375 Cow Ski Area (强连通分量)

题目地址:POJ 2375 对每一个点向与之相邻并h小于该点的点加有向边. 然后强连通缩点.问题就转化成了最少加几条边使得图为强连通图,取入度为0和出度为0的点数的较大者就可以.注意,当强连通分量仅仅有一个的时候.答案是0,而不是1. 代码例如以下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm> #in